package org.openxma.dsl.reference.ui.layouting.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of AbsoluteCharAttachment.
 * It implements the widgets and models of the page.
 *
 */
public abstract class AbsoluteCharAttachmentGen extends org.openxma.dsl.platform.xma.client.DslNotebookPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    private Scaler scaler = null;
    Group absoluteCharAttachment_composite_0_0W;
    Composite absoluteCharAttachment_composite_0_0_set0W;
    Label absoluteCharAttachment_composite_0_0_set0_centered;
    Text t1aW;
    ISimpleWMClient t1a;
    Composite absoluteCharAttachment_composite_0_0_set1W;
    Label absoluteCharAttachment_composite_0_0_set1_centered;
    Text t1bW;
    ISimpleWMClient t1b;
    Composite absoluteCharAttachment_composite_0_0_set2W;
    Label absoluteCharAttachment_composite_0_0_set2_centered;
    Text t1cW;
    ISimpleWMClient t1c;
    Composite absoluteCharAttachment_composite_0_0_set3W;
    Label absoluteCharAttachment_composite_0_0_set3_centered;
    Text t1dW;
    ISimpleWMClient t1d;
    Composite absoluteCharAttachment_composite_0_0_set4W;
    Label absoluteCharAttachment_composite_0_0_set4_centered;
    Text t1eW;
    ISimpleWMClient t1e;
    Composite absoluteCharAttachment_composite_0_0_set5W;
    Label absoluteCharAttachment_composite_0_0_set5_centered;
    Text t1fW;
    ISimpleWMClient t1f;
    Composite absoluteCharAttachment_composite_0_0_set6W;
    Label absoluteCharAttachment_composite_0_0_set6_centered;
    Text t1gW;
    ISimpleWMClient t1g;
    Composite absoluteCharAttachment_composite_0_0_set7W;
    Label absoluteCharAttachment_composite_0_0_set7_centered;
    Text t1hW;
    ISimpleWMClient t1h;
    Composite absoluteCharAttachment_composite_0_0_set8W;
    Label absoluteCharAttachment_composite_0_0_set8_centered;
    Text t1iW;
    ISimpleWMClient t1i;
    Composite absoluteCharAttachment_composite_0_0_set9W;
    Label absoluteCharAttachment_composite_0_0_set9_centered;
    Text t1jW;
    ISimpleWMClient t1j;
    Composite absoluteCharAttachment_composite_0_0_set10W;
    Label absoluteCharAttachment_composite_0_0_set10_centered;
    Text t1kW;
    ISimpleWMClient t1k;
    Composite absoluteCharAttachment_composite_0_0_set11W;
    Label absoluteCharAttachment_composite_0_0_set11_centered;
    Text t1lW;
    ISimpleWMClient t1l;
    Composite absoluteCharAttachment_composite_0_0_set12W;
    Label absoluteCharAttachment_composite_0_0_set12_centered;
    Text t1mW;
    ISimpleWMClient t1m;
    Composite absoluteCharAttachment_composite_0_0_set13W;
    Label absoluteCharAttachment_composite_0_0_set13_centered;
    Text t1nW;
    ISimpleWMClient t1n;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the AbsoluteCharAttachmentGen.
     * @param notebook the Notebook this page belongs to.
     */
    public AbsoluteCharAttachmentGen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",getGenPageLocale());
        }
        return genPageMessages;
    }

    /*
     * returns the scaler used for this page
    */
    final protected Scaler getScaler() {
        if (scaler == null) {
            scaler = Scaler.getInstance(getComposite());
        }
        return scaler;
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        t1a = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1a.setFmt(formatter);
        t1b = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1b.setFmt(formatter);
        t1c = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1c.setFmt(formatter);
        t1d = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1d.setFmt(formatter);
        t1e = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1e.setFmt(formatter);
        t1f = new SimpleWMClient((short) 5, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1f.setFmt(formatter);
        t1g = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1g.setFmt(formatter);
        t1h = new SimpleWMClient((short) 7, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1h.setFmt(formatter);
        t1i = new SimpleWMClient((short) 8, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1i.setFmt(formatter);
        t1j = new SimpleWMClient((short) 9, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1j.setFmt(formatter);
        t1k = new SimpleWMClient((short) 10, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1k.setFmt(formatter);
        t1l = new SimpleWMClient((short) 11, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1l.setFmt(formatter);
        t1m = new SimpleWMClient((short) 12, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1m.setFmt(formatter);
        t1n = new SimpleWMClient((short) 13, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1n.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1d, (WModel) t1e, (WModel) t1f, (WModel) t1g, (WModel) t1h, (WModel) t1i, (WModel) t1j, (WModel) t1k, (WModel) t1l, (WModel) t1m, (WModel) t1n };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        t1a = null;
        t1b = null;
        t1c = null;
        t1d = null;
        t1e = null;
        t1f = null;
        t1g = null;
        t1h = null;
        t1i = null;
        t1j = null;
        t1k = null;
        t1l = null;
        t1m = null;
        t1n = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.AbsoluteCharAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = getScaler();

        Composite pageCompositeabsoluteCharAttachmentW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositeabsoluteCharAttachmentW.setLayout(layout);

        absoluteCharAttachment_composite_0_0W = new Group(pageCompositeabsoluteCharAttachmentW,SWT.NONE);
        absoluteCharAttachment_composite_0_0W.setText(getGenPageMessages().getString("AbsoluteCharAttachment.absoluteCharAttachment_composite_0_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        absoluteCharAttachment_composite_0_0W.setLayout(layout);

        absoluteCharAttachment_composite_0_0_set0W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set0W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set0W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set0W");

        absoluteCharAttachment_composite_0_0_set0_centered = new Label(absoluteCharAttachment_composite_0_0_set0W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set0_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set0_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set0_centered");

        t1aW = new Text(absoluteCharAttachment_composite_0_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1aW.setData("WIDGET_ID","t1aW");
        t1aW.addFocusListener(adapter);
        t1aW.addModifyListener(adapter);
        t1aW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set1W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set1W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set1W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set1W");

        absoluteCharAttachment_composite_0_0_set1_centered = new Label(absoluteCharAttachment_composite_0_0_set1W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set1_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set1_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set1_centered");

        t1bW = new Text(absoluteCharAttachment_composite_0_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1bW.setData("WIDGET_ID","t1bW");
        t1bW.addFocusListener(adapter);
        t1bW.addModifyListener(adapter);
        t1bW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set2W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set2W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set2W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set2W");

        absoluteCharAttachment_composite_0_0_set2_centered = new Label(absoluteCharAttachment_composite_0_0_set2W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set2_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set2_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set2_centered");

        t1cW = new Text(absoluteCharAttachment_composite_0_0_set2W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1cW.setData("WIDGET_ID","t1cW");
        t1cW.addFocusListener(adapter);
        t1cW.addModifyListener(adapter);
        t1cW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set3W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set3W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set3W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set3W");

        absoluteCharAttachment_composite_0_0_set3_centered = new Label(absoluteCharAttachment_composite_0_0_set3W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set3_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set3_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set3_centered");

        t1dW = new Text(absoluteCharAttachment_composite_0_0_set3W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1dW.setData("WIDGET_ID","t1dW");
        t1dW.addFocusListener(adapter);
        t1dW.addModifyListener(adapter);
        t1dW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set4W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set4W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set4W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set4W");

        absoluteCharAttachment_composite_0_0_set4_centered = new Label(absoluteCharAttachment_composite_0_0_set4W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set4_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set4_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set4_centered");

        t1eW = new Text(absoluteCharAttachment_composite_0_0_set4W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1eW.setData("WIDGET_ID","t1eW");
        t1eW.addFocusListener(adapter);
        t1eW.addModifyListener(adapter);
        t1eW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set5W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set5W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set5W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set5W");

        absoluteCharAttachment_composite_0_0_set5_centered = new Label(absoluteCharAttachment_composite_0_0_set5W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set5_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set5_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set5_centered");

        t1fW = new Text(absoluteCharAttachment_composite_0_0_set5W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1fW.setData("WIDGET_ID","t1fW");
        t1fW.addFocusListener(adapter);
        t1fW.addModifyListener(adapter);
        t1fW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set6W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set6W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set6W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set6W");

        absoluteCharAttachment_composite_0_0_set6_centered = new Label(absoluteCharAttachment_composite_0_0_set6W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set6_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set6_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set6_centered");

        t1gW = new Text(absoluteCharAttachment_composite_0_0_set6W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1gW.setData("WIDGET_ID","t1gW");
        t1gW.addFocusListener(adapter);
        t1gW.addModifyListener(adapter);
        t1gW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set7W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set7W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set7W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set7W");

        absoluteCharAttachment_composite_0_0_set7_centered = new Label(absoluteCharAttachment_composite_0_0_set7W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set7_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set7_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set7_centered");

        t1hW = new Text(absoluteCharAttachment_composite_0_0_set7W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1hW.setData("WIDGET_ID","t1hW");
        t1hW.addFocusListener(adapter);
        t1hW.addModifyListener(adapter);
        t1hW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set8W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set8W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set8W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set8W");

        absoluteCharAttachment_composite_0_0_set8_centered = new Label(absoluteCharAttachment_composite_0_0_set8W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set8_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set8_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set8_centered");

        t1iW = new Text(absoluteCharAttachment_composite_0_0_set8W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1iW.setData("WIDGET_ID","t1iW");
        t1iW.addFocusListener(adapter);
        t1iW.addModifyListener(adapter);
        t1iW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set9W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set9W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set9W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set9W");

        absoluteCharAttachment_composite_0_0_set9_centered = new Label(absoluteCharAttachment_composite_0_0_set9W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set9_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set9_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set9_centered");

        t1jW = new Text(absoluteCharAttachment_composite_0_0_set9W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1jW.setData("WIDGET_ID","t1jW");
        t1jW.addFocusListener(adapter);
        t1jW.addModifyListener(adapter);
        t1jW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set10W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set10W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set10W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set10W");

        absoluteCharAttachment_composite_0_0_set10_centered = new Label(absoluteCharAttachment_composite_0_0_set10W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set10_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set10_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set10_centered");

        t1kW = new Text(absoluteCharAttachment_composite_0_0_set10W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1kW.setData("WIDGET_ID","t1kW");
        t1kW.addFocusListener(adapter);
        t1kW.addModifyListener(adapter);
        t1kW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set11W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set11W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set11W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set11W");

        absoluteCharAttachment_composite_0_0_set11_centered = new Label(absoluteCharAttachment_composite_0_0_set11W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set11_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set11_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set11_centered");

        t1lW = new Text(absoluteCharAttachment_composite_0_0_set11W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1lW.setData("WIDGET_ID","t1lW");
        t1lW.addFocusListener(adapter);
        t1lW.addModifyListener(adapter);
        t1lW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set12W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set12W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set12W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set12W");

        absoluteCharAttachment_composite_0_0_set12_centered = new Label(absoluteCharAttachment_composite_0_0_set12W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set12_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set12_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set12_centered");

        t1mW = new Text(absoluteCharAttachment_composite_0_0_set12W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1mW.setData("WIDGET_ID","t1mW");
        t1mW.addFocusListener(adapter);
        t1mW.addModifyListener(adapter);
        t1mW.addVerifyListener(adapter);

        absoluteCharAttachment_composite_0_0_set13W = new Composite(absoluteCharAttachment_composite_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        absoluteCharAttachment_composite_0_0_set13W.setLayout(layout);
        absoluteCharAttachment_composite_0_0_set13W.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set13W");

        absoluteCharAttachment_composite_0_0_set13_centered = new Label(absoluteCharAttachment_composite_0_0_set13W,SWT.LEFT);
        absoluteCharAttachment_composite_0_0_set13_centered.setVisible(false);
        absoluteCharAttachment_composite_0_0_set13_centered.setData("WIDGET_ID","absoluteCharAttachment_composite_0_0_set13_centered");

        t1nW = new Text(absoluteCharAttachment_composite_0_0_set13W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1nW.setData("WIDGET_ID","t1nW");
        t1nW.addFocusListener(adapter);
        t1nW.addModifyListener(adapter);
        t1nW.addVerifyListener(adapter);

        widgets = new Control[] { absoluteCharAttachment_composite_0_0W, absoluteCharAttachment_composite_0_0_set0W, absoluteCharAttachment_composite_0_0_set0_centered, t1aW, absoluteCharAttachment_composite_0_0_set1W, absoluteCharAttachment_composite_0_0_set1_centered, t1bW, absoluteCharAttachment_composite_0_0_set2W, absoluteCharAttachment_composite_0_0_set2_centered, t1cW, absoluteCharAttachment_composite_0_0_set3W, absoluteCharAttachment_composite_0_0_set3_centered, t1dW, absoluteCharAttachment_composite_0_0_set4W, absoluteCharAttachment_composite_0_0_set4_centered, t1eW, absoluteCharAttachment_composite_0_0_set5W, absoluteCharAttachment_composite_0_0_set5_centered, t1fW, absoluteCharAttachment_composite_0_0_set6W, absoluteCharAttachment_composite_0_0_set6_centered, t1gW, absoluteCharAttachment_composite_0_0_set7W, absoluteCharAttachment_composite_0_0_set7_centered, t1hW, absoluteCharAttachment_composite_0_0_set8W, absoluteCharAttachment_composite_0_0_set8_centered, t1iW, absoluteCharAttachment_composite_0_0_set9W, absoluteCharAttachment_composite_0_0_set9_centered, t1jW, absoluteCharAttachment_composite_0_0_set10W, absoluteCharAttachment_composite_0_0_set10_centered, t1kW, absoluteCharAttachment_composite_0_0_set11W, absoluteCharAttachment_composite_0_0_set11_centered, t1lW, absoluteCharAttachment_composite_0_0_set12W, absoluteCharAttachment_composite_0_0_set12_centered, t1mW, absoluteCharAttachment_composite_0_0_set13W, absoluteCharAttachment_composite_0_0_set13_centered, t1nW };

        createWidgetsLayout();
        createWidgetsTabOrder();

    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = getScaler();
        Control lastControl;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set0W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set1W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set2W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set3W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set3W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set4W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set4W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set5W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set5W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set6W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set6W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set7W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set7W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set8W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set8W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set9W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set9W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set10W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set10W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set11W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set11W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set12W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set12W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        absoluteCharAttachment_composite_0_0_set13W.setLayoutData(data);
        lastControl=absoluteCharAttachment_composite_0_0_set13W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(70));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1aW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(70));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1bW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(70));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1cW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set3_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(70));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1dW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set4_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1eW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set5_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1fW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set6_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set6_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1gW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set7_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set7_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1hW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set8_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set8_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1iW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set9_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set9_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1jW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set10_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set10_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1kW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set11_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set11_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1lW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set12_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set12_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1mW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        absoluteCharAttachment_composite_0_0_set13_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(14));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(14));
        data.top = new FormAttachment(absoluteCharAttachment_composite_0_0_set13_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        t1nW.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Composite pageCompositeabsoluteCharAttachmentW = getComposite();
        tabOrder = new Control[1];
        tabOrder[0] = absoluteCharAttachment_composite_0_0W;
        pageCompositeabsoluteCharAttachmentW.setTabList(tabOrder);
        tabOrder = new Control[14];
        tabOrder[0] = absoluteCharAttachment_composite_0_0_set0W;
        tabOrder[1] = absoluteCharAttachment_composite_0_0_set1W;
        tabOrder[2] = absoluteCharAttachment_composite_0_0_set2W;
        tabOrder[3] = absoluteCharAttachment_composite_0_0_set3W;
        tabOrder[4] = absoluteCharAttachment_composite_0_0_set4W;
        tabOrder[5] = absoluteCharAttachment_composite_0_0_set5W;
        tabOrder[6] = absoluteCharAttachment_composite_0_0_set6W;
        tabOrder[7] = absoluteCharAttachment_composite_0_0_set7W;
        tabOrder[8] = absoluteCharAttachment_composite_0_0_set8W;
        tabOrder[9] = absoluteCharAttachment_composite_0_0_set9W;
        tabOrder[10] = absoluteCharAttachment_composite_0_0_set10W;
        tabOrder[11] = absoluteCharAttachment_composite_0_0_set11W;
        tabOrder[12] = absoluteCharAttachment_composite_0_0_set12W;
        tabOrder[13] = absoluteCharAttachment_composite_0_0_set13W;
        absoluteCharAttachment_composite_0_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1aW;
        absoluteCharAttachment_composite_0_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1bW;
        absoluteCharAttachment_composite_0_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1cW;
        absoluteCharAttachment_composite_0_0_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1dW;
        absoluteCharAttachment_composite_0_0_set3W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1eW;
        absoluteCharAttachment_composite_0_0_set4W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1fW;
        absoluteCharAttachment_composite_0_0_set5W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1gW;
        absoluteCharAttachment_composite_0_0_set6W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1hW;
        absoluteCharAttachment_composite_0_0_set7W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1iW;
        absoluteCharAttachment_composite_0_0_set8W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1jW;
        absoluteCharAttachment_composite_0_0_set9W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1kW;
        absoluteCharAttachment_composite_0_0_set10W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1lW;
        absoluteCharAttachment_composite_0_0_set11W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1mW;
        absoluteCharAttachment_composite_0_0_set12W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = t1nW;
        absoluteCharAttachment_composite_0_0_set13W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        absoluteCharAttachment_composite_0_0W = null;
        absoluteCharAttachment_composite_0_0_set0W = null;
        absoluteCharAttachment_composite_0_0_set0_centered = null;
        t1aW = null;
        absoluteCharAttachment_composite_0_0_set1W = null;
        absoluteCharAttachment_composite_0_0_set1_centered = null;
        t1bW = null;
        absoluteCharAttachment_composite_0_0_set2W = null;
        absoluteCharAttachment_composite_0_0_set2_centered = null;
        t1cW = null;
        absoluteCharAttachment_composite_0_0_set3W = null;
        absoluteCharAttachment_composite_0_0_set3_centered = null;
        t1dW = null;
        absoluteCharAttachment_composite_0_0_set4W = null;
        absoluteCharAttachment_composite_0_0_set4_centered = null;
        t1eW = null;
        absoluteCharAttachment_composite_0_0_set5W = null;
        absoluteCharAttachment_composite_0_0_set5_centered = null;
        t1fW = null;
        absoluteCharAttachment_composite_0_0_set6W = null;
        absoluteCharAttachment_composite_0_0_set6_centered = null;
        t1gW = null;
        absoluteCharAttachment_composite_0_0_set7W = null;
        absoluteCharAttachment_composite_0_0_set7_centered = null;
        t1hW = null;
        absoluteCharAttachment_composite_0_0_set8W = null;
        absoluteCharAttachment_composite_0_0_set8_centered = null;
        t1iW = null;
        absoluteCharAttachment_composite_0_0_set9W = null;
        absoluteCharAttachment_composite_0_0_set9_centered = null;
        t1jW = null;
        absoluteCharAttachment_composite_0_0_set10W = null;
        absoluteCharAttachment_composite_0_0_set10_centered = null;
        t1kW = null;
        absoluteCharAttachment_composite_0_0_set11W = null;
        absoluteCharAttachment_composite_0_0_set11_centered = null;
        t1lW = null;
        absoluteCharAttachment_composite_0_0_set12W = null;
        absoluteCharAttachment_composite_0_0_set12_centered = null;
        t1mW = null;
        absoluteCharAttachment_composite_0_0_set13W = null;
        absoluteCharAttachment_composite_0_0_set13_centered = null;
        t1nW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        t1aW.setData(t1a.getUIDelegate());
        t1a.getUIDelegate().attachUI(t1aW,null);
        t1bW.setData(t1b.getUIDelegate());
        t1b.getUIDelegate().attachUI(t1bW,null);
        t1cW.setData(t1c.getUIDelegate());
        t1c.getUIDelegate().attachUI(t1cW,null);
        t1dW.setData(t1d.getUIDelegate());
        t1d.getUIDelegate().attachUI(t1dW,null);
        t1eW.setData(t1e.getUIDelegate());
        t1e.getUIDelegate().attachUI(t1eW,null);
        t1fW.setData(t1f.getUIDelegate());
        t1f.getUIDelegate().attachUI(t1fW,null);
        t1gW.setData(t1g.getUIDelegate());
        t1g.getUIDelegate().attachUI(t1gW,null);
        t1hW.setData(t1h.getUIDelegate());
        t1h.getUIDelegate().attachUI(t1hW,null);
        t1iW.setData(t1i.getUIDelegate());
        t1i.getUIDelegate().attachUI(t1iW,null);
        t1jW.setData(t1j.getUIDelegate());
        t1j.getUIDelegate().attachUI(t1jW,null);
        t1kW.setData(t1k.getUIDelegate());
        t1k.getUIDelegate().attachUI(t1kW,null);
        t1lW.setData(t1l.getUIDelegate());
        t1l.getUIDelegate().attachUI(t1lW,null);
        t1mW.setData(t1m.getUIDelegate());
        t1m.getUIDelegate().attachUI(t1mW,null);
        t1nW.setData(t1n.getUIDelegate());
        t1n.getUIDelegate().attachUI(t1nW,null);
    }

    /**
     * This method will be called every time the AbsoluteCharAttachment becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder LayoutingPage_tabfolder_0_0_0_0W,int index) {
        TabItem absoluteCharAttachmentW = new TabItem (LayoutingPage_tabfolder_0_0_0_0W, SWT.NULL, index);
        absoluteCharAttachmentW.setText(getGenPageMessages().getString("AbsoluteCharAttachment"));
        absoluteCharAttachmentW.setControl(getComposite());
        absoluteCharAttachmentW.setData(this);

        return absoluteCharAttachmentW;
    }
}
