package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.reference.base.validation.BaseEntityValidator;
import org.openxma.dsl.reference.model.Supplier;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class SupplierGenValidator extends BaseEntityValidator {
    
    public boolean isCompanyNameRequired(Supplier supplier) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Supplier.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Supplier supplier) {
        Errors errors = createErrors(supplier);      
        super.validate(supplier,errors);
        validate(supplier,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Supplier supplier = (Supplier) object;
        if (isCompanyNameRequired(supplier)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "companyName", "field.required");
        }
        rejectIfMaxLength(errors,"companyName",supplier.getCompanyName(),25);
    }
    
}
